<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    <script>
        // function suma(a,b){
        //     return new Promise(function(resolve, reject){
        //         resolve(a + b);
        //     })
        // }

        // function restar(valor,cantidad){
        //     return new Promise(function(resolve, reject){
        //         resolve(valor - cantidad);
        //     })
        // }
        // function esMayorACero(valor){
        //     return new Promise(function(resolve,reject){
        //         if(valor>0){
        //             resolve('mayor que 0');
        //         }
        //         else{
        //             resolve('menor que 0');
        //         }
        //     })
        // }
        // const x = 10
        // const y = 20
        // async function mayorACero(){
        //     try{
        //         let resultado_de_suma = await suma(x,y)
        //         let resultado_de_resta = await restar(resultado_de_suma, 15)
        //         let respuesta = await esMayorACero(resultado_de_resta)
        //         console.log(respuesta);
        //     }
        //     catch (err){
        //     console.log(err)
        //     }
        // }
        // mayorACero();


        // let people = [
        //     {
        //         name: "bob", id:1
        //     },
        //     {
        //         name: "john", id:2
        //     },
        //     {
        //         name: "aledx", id:3
        //     },
        //     {
        //         name: "john", id:3
        //     }
        // ];
        // let people_name = people.map(person => person.name)
        // console.log(people_name);
        // let counter = people_name.reduce((count, item)=>{
        //     count[item] = (count[item] || 0)+1;
        //     return count;
        // },{})

        function Forma(id){
            this.id = id;
        }

        Forma.prototype.gritar = function(){
            console.log("Yep!!!");
        }

        function Cuadrado(id, ladoA, ladoB, ladoC, ladoD){
            Forma.call(this,id);
            this.ladoA = ladoA;
            this.ladoB = ladoB;
            this.ladoC = ladoC;
            this.ladoD = ladoD;
        }

        Cuadrado.prototype=Object.create(Forma.prototype);

        Cuadrado.prototype.getLados = function(){
            return [this.ladoA,this.ladoB,this.ladoC,this.ladoD];
        }
        const instaciaCuadrado = new Cuadrado(1001,10,10,10,10);
        console.log(instaciaCuadrado);
        console.log(instaciaCuadrado.getLados());
        instaciaCuadrado.gritar()
    </script>
</body>
</html>